import { Tensor } from '../tensor';
import { TensorLike } from '../types';
declare function add_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function addN_<T extends Tensor>(tensors: Array<T | TensorLike>): T;
declare function addStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function sub_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function subStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function pow_<T extends Tensor>(base: T | TensorLike, exp: Tensor | TensorLike): T;
declare function powStrict_<T extends Tensor>(base: T, exp: Tensor): T;
declare function mul_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function mulStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function div_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function floorDiv_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function divStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function mod_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function modStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function minimum_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function minimumStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function maximum_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function maximumStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function squaredDifference_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
declare function squaredDifferenceStrict_<T extends Tensor>(a: T | TensorLike, b: T | TensorLike): T;
declare function atan2_<T extends Tensor>(a: Tensor | TensorLike, b: Tensor | TensorLike): T;
export declare const add: typeof add_;
export declare const addN: typeof addN_;
export declare const addStrict: typeof addStrict_;
export declare const atan2: typeof atan2_;
export declare const div: typeof div_;
export declare const divStrict: typeof divStrict_;
export declare const floorDiv: typeof floorDiv_;
export declare const maximum: typeof maximum_;
export declare const maximumStrict: typeof maximumStrict_;
export declare const minimum: typeof minimum_;
export declare const minimumStrict: typeof minimumStrict_;
export declare const mod: typeof mod_;
export declare const modStrict: typeof modStrict_;
export declare const mul: typeof mul_;
export declare const mulStrict: typeof mulStrict_;
export declare const pow: typeof pow_;
export declare const powStrict: typeof powStrict_;
export declare const squaredDifference: typeof squaredDifference_;
export declare const squaredDifferenceStrict: typeof squaredDifferenceStrict_;
export declare const sub: typeof sub_;
export declare const subStrict: typeof subStrict_;
export {};
